local version = "1.0.3 alpha"
LootWhatIWant = { }
LootWhatIWantMobDB = { }
LootWhatIWant.enabled = true
LootWhatIWant.blacklist = { }
LootWhatIWant.blacklistcount = { }
LootWhatIWantMobDB.MobDB = { }
LootWhatIWant.tracked = { }
LootWhatIWant.trackedcount = { }
LootWhatIWantMobDB.loots = { }
LootWhatIWantMobDB.MobList = { }
LootWhatIWantMobDB.tracking = false
LootWhatIWantMobDB.MobDB = {}
LootWhatIWant.activeInGroup = false
LootWhatIWant.deleteItems = false
LootWhatIWant.kzloot = false
LootWhatIWant.mcloot = false
LootWhatIWant.zgloot = false
LootWhatIWant.mouseover = false
LootWhatIWant.blacklist_GUI_linenumber = 0
LootWhatIWant.tracklist_GUI_linenumber = 0
LootWhatIWant.MobList_GUI_mobname = nil
local LootBlacklist = 0
local LootedItem = ""
local blacklisted = false
local LootWhatIWant_Frame = CreateFrame("Frame", "LootWhatIWantFrame")

GameTooltip:HookScript("OnTooltipSetUnit", function(self, ...)	
	if not LootWhatIWant.enabled then return end
	if not LootWhatIWant.mouseover then return end
	if not LootWhatIWantMobDB.tracking then return end
	if (UnitIsPlayer('mouseover')) then return end -- Don't care if non npc
	if (GetUnitName("mouseover") == nil) then return end
	local mobname = string.lower(GetUnitName("mouseover"))
	if(LootWhatIWantMobDB.loots[mobname] ~= nil) then
		GameTooltip:AddLine("Looted: "..LootWhatIWantMobDB.loots[mobname])
	end
	if (LootWhatIWantMobDB.MobDB[mobname] ~= nil) then
		for n = 1, #LootWhatIWantMobDB.MobDB[mobname] do
			if (LootWhatIWant.tracked[LootWhatIWantMobDB.MobDB[mobname][n][3]] ~= nil)  then
				local droppct = LootWhatIWantMobDB.MobDB[mobname][n][2] / LootWhatIWantMobDB.loots[mobname]
				droppct = droppct * 100
				droppct = droppct * 100
				droppct = floor(droppct)
				droppct = droppct / 100
				if(LootWhatIWantMobDB.MobDB[mobname][n][4] == 1) then
					GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..""..LootWhatIWantMobDB.MobDB[mobname][n][1].."|r x"..HIGHLIGHT_FONT_COLOR_CODE..""..LootWhatIWantMobDB.MobDB[mobname][n][2].."|r - "..droppct.."%")
				elseif(LootWhatIWantMobDB.MobDB[mobname][n][4] == 2) then
					GameTooltip:AddLine(GREEN_FONT_COLOR_CODE..""..LootWhatIWantMobDB.MobDB[mobname][n][1].."|r x"..GREEN_FONT_COLOR_CODE..""..LootWhatIWantMobDB.MobDB[mobname][n][2].."|r - "..droppct.."%")
				elseif(LootWhatIWantMobDB.MobDB[mobname][n][4] == 3) then
					GameTooltip:AddLine("|cff0080ff"..LootWhatIWantMobDB.MobDB[mobname][n][1].."|r x|cff0080ff"..LootWhatIWantMobDB.MobDB[mobname][n][2].."|r - "..droppct.."%")				
				else	
					GameTooltip:AddLine(LootWhatIWantMobDB.MobDB[mobname][n][1].." x"..HIGHLIGHT_FONT_COLOR_CODE..""..LootWhatIWantMobDB.MobDB[mobname][n][2].."|r - "..droppct.."%")								
				end
			end
		end
	end
	

	
end)

function LWIW_InGroup()
	if (GetNumRaidMembers() > 0) or (GetNumPartyMembers() > 0) then
		if (LootWhatIWant.activeInGroup) then
			return true
		elseif (GetRealZoneText() == "Zul'Gurub") and (LootWhatIWant.zgloot) then
			return true
		elseif (GetRealZoneText() == "Molten Core") and (LootWhatIWant.mcloot) then
			return true
		elseif(GetRealZoneText() == "Karazhan") and (LootWhatIWant.kzloot) then
			return true
		else
			return false
		end
	else
		return true
	end
end


function LootWhatIWant_LOOT_OPENED()
	if not (LootWhatIWant.enabled) then return end
	if (LootWhatIWantMobDB.MobDB == nil) then
		LootWhatIWantMobDB.MobDB = { }
	end
	if (event == "LOOT_OPENED") then
		blacklisted = false
		LootBlacklist = 0
		local auloot = GetCVar("autoLootDefault")
		local mobname
		if (GetUnitName("target") == nil) then
			mobname = nil
		else
			if (UnitIsDead("target")) then
				mobname = string.lower(GetUnitName("target"))
			else
				mobname = nil
			end
		end
		if (auloot == "1") then
			if (LootWhatIWant.enabled == true) then
				print("Auto loot is on, LootWhatIWant can not work with that.  Please disable LWIW or AutoLoot (in your interface settings).")
				return
			end
		else
			if (LootWhatIWantMobDB.tracking) then
				if(mobname ~= nil) then
					if(LootWhatIWantMobDB.loots == nil) then
						LootWhatIWantMobDB.loots = { }
					end
					if (LootWhatIWantMobDB.loots[mobname] == nil) then
						LootWhatIWantMobDB.loots[mobname] = 1
					else
						LootWhatIWantMobDB.loots[mobname] = LootWhatIWantMobDB.loots[mobname] + 1
					end
				end
			end
			if (GetNumLootItems() > 0) then
				for i = 1, GetNumLootItems() do
					curSlot = i
					
					local lootIcon, lootName, lootQuantity, rarity, locked = GetLootSlotInfo(i)
					local item
					local itemstring
					if (lootQuantity ~= 0) then
						item = string.match(GetLootSlotLink(i), "item:(%d+)") 
						itemstring = GetLootSlotLink(i)
					
					
						if LootWhatIWantMobDB.tracking then
							if (mobname ~= nil) then
								if (LootWhatIWantMobDB.MobDB[mobname] == nil) then
									LootWhatIWantMobDB.MobDB[mobname] = { }
									LootWhatIWantMobDB.MobDB[mobname][1] = { }
									local test = { }
									test[1] = lootName
									test[2] = lootQuantity
									test[3] = item
									test[4] = rarity
									test[5] = itemstring
									LootWhatIWantMobDB.MobDB[mobname][1] = test
									if (LootWhatIWantMobDB.MobList == nil) then
										LootWhatIWantMobDB.MobList = { }
										LootWhatIWantMobDB.MobList[1] = mobname
									else
										LootWhatIWantMobDB.MobList[(#LootWhatIWantMobDB.MobList + 1)] = mobname
									end
								else
									local addednew = false
									for n = 1, #LootWhatIWantMobDB.MobDB[mobname] do
										if (LootWhatIWantMobDB.MobDB[mobname][n][3] == item) then
											LootWhatIWantMobDB.MobDB[mobname][n][2] = LootWhatIWantMobDB.MobDB[mobname][n][2] + lootQuantity
											addednew = true
										end
									end
									if not (addednew) then
										local nn = #LootWhatIWantMobDB.MobDB[mobname]
										local test = { }
										test[1] = lootName
										test[2] = lootQuantity
										test[3] = item
										test[4] = rarity
										test[5] = itemstring
										LootWhatIWantMobDB.MobDB[mobname][(nn+1)] = test
									end
								
								end
							end
						end
					else
						if LootWhatIWantMobDB.tracking then
							if (mobname ~= nil) then
								if (LootWhatIWantMobDB.MobDB[mobname] == nil) then
									LootWhatIWantMobDB.MobDB[mobname] = { }
									LootWhatIWantMobDB.MobDB[mobname][1] = { }
									local test = { }
									test[1] = "coin"
									
									local copper = (string.match(lootName, "(%d+) Copper"))
									local silver = (string.match(lootName, "(%d+) Silver"))
									local gold = (string.match(lootName, "(%d+) Gold"))
									if (silver ~= nil) then
										silver = silver * 100
									else
										silver = 0
									end
									if (copper == nil) then
										copper = 0
									end
									if (gold ~= nil) then
										gold = gold * 10000
									else
										gold = 0
									end
									local totalcoin = gold + silver + copper
									
									test[2] = totalcoin
									
									test[3] = "coin"
									test[4] = "coin"
									test[5] = "coin"
									LootWhatIWantMobDB.MobDB[mobname][1] = test
									if (LootWhatIWantMobDB.MobList == nil) then
										LootWhatIWantMobDB.MobList = { }
										LootWhatIWantMobDB.MobList[1] = mobname
									else
										LootWhatIWantMobDB.MobList[(#LootWhatIWantMobDB.MobList + 1)] = mobname
									end
								else
									local addednew = false
									for n = 1, #LootWhatIWantMobDB.MobDB[mobname] do
										if (LootWhatIWantMobDB.MobDB[mobname][n][3] == "coin") then
											local copper = (string.match(lootName, "(%d+) Copper"))
											local silver = (string.match(lootName, "(%d+) Silver"))
											local gold = (string.match(lootName, "(%d+) Gold"))
											if (silver ~= nil) then
												silver = silver * 100
											else
												silver = 0
											end
											if (copper == nil) then
												copper = 0
											end
											if (gold ~= nil) then
												gold = gold * 10000
											else
												gold = 0
											end
											local totalcoin = gold + silver + copper
											LootWhatIWantMobDB.MobDB[mobname][n][2] = LootWhatIWantMobDB.MobDB[mobname][n][2] + totalcoin
											addednew = true
										end
									end
									if not (addednew) then
										local nn = #LootWhatIWantMobDB.MobDB[mobname]
										local test = { }
										test[1] = "coin"
										
										local copper = (string.match(lootName, "(%d+) Copper"))
										local silver = (string.match(lootName, "(%d+) Silver"))
										local gold = (string.match(lootName, "(%d+) Gold"))
										if (silver ~= nil) then
											silver = silver * 100
										else
											silver = 0
										end
										if (copper == nil) then
											copper = 0
										end
										if (gold ~= nil) then
											gold = gold * 10000
										else
											gold = 0
										end
										local totalcoin = gold + silver + copper
										
										test[2] = totalcoin
										
										test[3] = "coin"
										test[4] = "coin"
										test[5] = "coin"
										LootWhatIWantMobDB.MobDB[mobname][(nn+1)] = test
									end
									
								end
								
							end
						end
					end
					if not (LootWhatIWant.blacklist[item]) then
						if (locked ~= 1) then
							LootSlot(i)
							if LWIW_InGroup() then
								StaticPopup_Hide("LOOT_BIND")
								ConfirmLootSlot(i)
							end
						end
					else
						if (LootWhatIWant.deleteItems) then
							if (locked ~= 1) then
								blacklisted = true
								LootBlacklist = LootBlacklist + 1
								LootSlot(i)
								if LWIW_InGroup() then
									StaticPopup_Hide("LOOT_BIND")
									ConfirmLootSlot(i)
								end
								
							end
						else
							print("here")
							
							--wasn't sure if i wanted to put a print here to let people know it was ignored or not.
						end
					end
					
				end
			else
				CloseLoot()
			end
		end
	elseif (event == "BAG_UPDATE") then
		if (blacklisted) then
			LWIW_Delete()
			blacklisted = false
		end
	end
end

function LWIW_Delete()
	for bag = 0, NUM_BAG_SLOTS do
		for slot=1, GetContainerNumSlots(bag) do
			local texture, count, locked, quality, readable, lootable, link = GetContainerItemInfo(bag, slot)
			if (link ~= nil) then
				local iitem = string.match(link, "item:(%d+)")
				if (iitem ~= nil) then
					if (LootWhatIWant.blacklist[iitem]) then
						PickupContainerItem(bag, slot)
						DeleteCursorItem()
						print("Deleted: "..link)
						
					end
				end
				
			end
		end
	end
end

function LWIW_Add(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ~= nil) then
		print(name.." is already in your blacklist.")
	else
		print(name.." has been added to your blacklist.")
		LootWhatIWant.blacklist[itemnum] = name
		if (LootWhatIWant.blacklistcount == nil) then
			LootWhatIWant.blacklistcount = {}
			LootWhatIWant.blacklistcount[1] = itemnum
		else
			LootWhatIWant.blacklistcount[(#LootWhatIWant.blacklistcount + 1)] = itemnum
		end
		LWIW_BlackListSB_Update()
	end
end

function LWIW_Remove(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ==  nil) then
		print(name.." is not in your blacklist.")
	else
		print(name.." has been removed from your blacklist.")
		LootWhatIWant.blacklist[itemnum] = nil
		for i = 1, #LootWhatIWant.blacklistcount do
			if (LootWhatIWant.blacklistcount[i] == itemnum) then
				table.remove(LootWhatIWant.blacklistcount, i)
				break
			end
		end
		LWIW_BlackListSB_Update()
	end
end

function LWIW_addTrack(itemnum, name)
	if (LootWhatIWant.tracked == nil) then
		LootWhatIWant.tracked = { }
	end
	if (LootWhatIWant.tracked[itemnum] ~= nil) then
		print(name.." is already being tracked.")
	else
		print(name.." is now being tracked")
		LootWhatIWant.tracked[itemnum] = name
		if (LootWhatIWant.trackedcount == nil) then
			LootWhatIWant.trackedcount = {}
			LootWhatIWant.trackedcount[1] = itemnum
		else
			LootWhatIWant.trackedcount[(#LootWhatIWant.trackedcount + 1)] = itemnum
		end
	end
	LWIW_TrackListSB_Update()
end

function LWIW_removeTrack(itemnum, name)	
	if (LootWhatIWant.tracked == nil) then
		LootWhatIWant.tracked = { }
	end
	if (LootWhatIWant.tracked[itemnum] ==  nil) then
		print(name.." is not in your trackedlist.")
	else
		print(name.." has been removed from your trackedlist.")
		LootWhatIWant.tracked[itemnum] = nil
		for i = 1, #LootWhatIWant.trackedcount do
			if (LootWhatIWant.trackedcount[i] == itemnum) then
				table.remove(LootWhatIWant.trackedcount, i)
				break
			end
		end
		LWIW_TrackListSB_Update()
	end
end

SLASH_LOOTWHATIWANT1 = "/lwiw"
SlashCmdList["LOOTWHATIWANT"] = function(msg)
	if( msg ) then
		--local command2 = string.lower(msg);
		local command, rest2 = msg:match("^(%S*)%s*(.-)$")
		local rest
		local itemnum = nil
		if (rest2 ~= "") then
			itemnum = string.match(rest2, "item:(%d+)")
			if(itemnum == nil) then
				print("Not a valid item link after add/remove/addtrack/removetrack command.")
				return
			end
		end
		command = string.lower(command)
		if (command == "add") then
			LWIW_Add(itemnum, rest2)
		elseif (command == "remove") then
			LWIW_Remove(itemnum, rest2)
		elseif(command == "disable") then
			print("LootWhatIWant disabled")
			LootWhatIWant.enabled = false
		elseif(command == "enable") then
			print("LootWhatIWant enabled")
			LootWhatIWant.enabled = true
		elseif(command == "delete") then
			if (LootWhatIWant.deleteItems) then
				print("Will NOT loot items but leave them on the corpse.")
				LootWhatIWant.deleteItems = false
			else
				LootWhatIWant.deleteItems = true
				print("Will auto delete items from your blacklist after looting.")
			end
		elseif(command == "addtrack") then
			LWIW_addTrack(itemnum, rest2)
		elseif(command == "removetrack") then
			LWIW_removeTrack(itemnum, rest2)
		elseif(command == "zg") then
			if (LootWhatIWant.zgloot) then
				LootWhatIWant.zgloot = false
				print("Will NOT auto loot in ZG.")
			else
				LootWhatIWant.zgloot = true
				print("Will AUTO loot in ZG.")
			end
		elseif(command == "kz") then
			if (LootWhatIWant.kzloot) then
				LootWhatIWant.kzloot = false
				print("Will NOT auto loot in Kara.")
			else
				LootWhatIWant.kzloot = true
				print("Will AUTO loot in Kara.")
			end
		elseif(command == "mc") then
			if (LootWhatIWant.mcloot) then
				LootWhatIWant.mcloot = false
				print("Will NOT auto loot in MC.")
			else
				LootWhatIWant.mcloot = true
				print("Will AUTO loot in MC")
			end
		elseif(command == "tracking") then
			if (LootWhatIWantMobDB.tracking) then
				LootWhatIWantMobDB.tracking = false
				print("Loot tracking disabled")
			else
				print("Loot tracking enabled")
				LootWhatIWantMobDB.tracking = true
			end
		elseif(command == "gui") then
			 InterfaceOptionsFrame_OpenToCategory(LootWhatIWant_panel)
		elseif(command == "mouseover") then
			if (LootWhatIWant.mouseover) then
				LootWhatIWant.mouseover= false
				print("Loot tracking displayed in mouseover disabled.")
			else
				LootWhatIWant.mouseover = true
				print("Loot tracking displayed in mouseover enabled.")
			end
		else
			print("LootWhatIWant Mod")
			print("usage /lwiw -- prints help")
			print("/lwiw add [item] -- add an item to the blacklist to not loot, must be in proper item format (ie shift click after the word add).")
			print("/lwiw remove [item] -- remove an item from the blacklist, must be in proper item format (ie shift click after the word add).")
			print("/lwiw addtrack [item] -- add an item for loot tracking")
			print("/lwiw removetrack [item] -- remove an item from loot tracking")
			print("/lwiw enable -- enable this addon")
			print("/lwiw disable -- disable this addon")
			print("/lwiw gui -- display gui")
			print("/wiw tracking -- toggle loot tracking on or  off, account wide, not character specific")
			print("/lwiw mouseover -- toggle displaying tracked items in tooltip")
			print("/lwiw zg or mc or kz -- enable/disable auto loot in ZG/MC/KZ respectivily.")
			print("/lwiw delete -- toogles looting then deleting items in your blacklist.  Disabled by default.  Have tested as much as I can, Use this at YOUR own risk.")
			print("this will not work while your in a group/raid.  If you want it to look in the lua file for activeInGroup and change to true.  Use at your own risk, not responsible for -dkp or whatever.")
		end
	end
end
LootWhatIWant_Frame:RegisterEvent("BAG_UPDATE")
--LootWhatIWant:RegisterEvent("LOOT_SLOT_CLEARED")
LootWhatIWant_Frame:RegisterEvent("LOOT_OPENED")

LootWhatIWant_Frame:SetScript("OnEvent", LootWhatIWant_LOOT_OPENED)